function replaceAll(str, find, replace,html,original) {
	if(!str) return ''
	if(!find) return str
	if(!replace) replace=''
	if(html) replace='<span class="red">'+replaceAll(find,'\\n','\\n↵')+'</span><span class="green">'+replace+'</span>'
	if(!original) find=escapeRegExp(find)
	return str.replace(new RegExp(find, 'gm'), replace);
}
function escapeRegExp(str) {
	return str.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "\\$1");
}
function filterEvent(event,filters) {
	allow=true
	filters.forEach(function(filter) {
		if(!allow) return
		thisfilter=true
		filter.forEach(function(action) {
			if(!thisfilter) return
			if(!event[action.field]) return
			found=event[action.field].indexOf(action.text) > -1
			if(action.action=="include" && !found) thisfilter=false
			if(action.action=="exclude" && found) thisfilter=false
		})
		if(thisfilter) allow=false
	})
	return allow
}
function replaceEvent(event,replaceInfo,html,original) {
	replaceInfo.forEach(function(replacePart) {
		event[replacePart.field]=replaceAll(event[replacePart.field],replacePart.from,replacePart.to,html,original)
	})
	return event
}
try {
	module.exports={replaceAll:replaceAll,filterEvent:filterEvent,replaceEvent:replaceEvent}
} catch (e) {}
